"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var avl_design = function avl_design(colorname, size) {
  //const bg = 'gray-50'
  var primary = 'gray';
  var highlight = 'white';
  var accent = 'blue'; //const secondary =  'green'

  return {
    sidenav: function sidenav() {
      var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var _opts$color = opts.color,
          color = _opts$color === void 0 ? 'white' : _opts$color,
          _opts$size = opts.size,
          size = _opts$size === void 0 ? 'compact' : _opts$size,
          _opts$subMenuStyle = opts.subMenuStyle,
          subMenuStyle = _opts$subMenuStyle === void 0 ? 'inline' : _opts$subMenuStyle;
      var colors = {
        white: {
          contentBg: "bg-".concat(highlight),
          contentBgAccent: "bg-neutral-100",
          accentColor: "".concat(accent, "-600"),
          accentBg: "hover:bg-".concat(accent, "-400"),
          borderColor: "border-".concat(primary, "-100"),
          textColor: "text-".concat(primary, "-600"),
          textColorAccent: "text-slate-800",
          highlightColor: "text-".concat(primary, "-800")
        },
        dark: {
          contentBg: "bg-neutral-800",
          contentBgAccent: "bg-neutral-900",
          accentColor: "white",
          accentBg: "",
          borderColor: "border-neutral-700",
          textColor: "text-slate-300",
          textColorAccent: "text-slate-100",
          highlightColor: "text-".concat(highlight)
        },
        bright: {
          contentBg: "bg-".concat(accent, "-700"),
          accentColor: "".concat(accent, "-400"),
          accentBg: "hover:bg-".concat(accent, "-400"),
          borderColor: "border-".concat(accent, "-600"),
          textColor: "text-".concat(highlight),
          highlightColor: "text-".concat(highlight)
        }
      };
      var sizes = {
        compact: {
          width: '44',
          wrapper: "w-44",
          sideItem: "flex mx-2 pr-4 py-2 text-base hover:pl-2",
          topItem: "flex items-center text-sm px-4 border-r h-12",
          icon: "mr-3 text-lg"
        },
        full: {
          width: "64",
          wrapper: "w-64",
          sideItem: "flex mx-4 pr-4 py-4 text-base font-base border-b hover:pl-4",
          topItem: "flex pr-4 py-2 text-sm font-light",
          icon: "mr-4 text-2xl"
        },
        mini: {
          width: "20",
          wrapper: "w-20 overflow-x-hidden",
          sideItem: "flex pr-4 py-4 text-base font-base border-b",
          topItem: "flex px-4 items-center text-sm font-light ",
          icon: "w-20 mr-4 text-5xl"
        },
        micro: {
          width: "14",
          wrapper: "w-14 overflow-x-hidden",
          sideItem: "flex pr-4 py-4 text-base font-base border-b",
          topItem: "flex mx-6 pr-4 py-2 text-sm font-light",
          icon: "w-14 mr-4 text-2xl",
          sideItemContent: 'hidden'
        },
        none: {
          width: "0",
          wrapper: "w-0 overflow-hidden",
          sideItem: "flex mx-2 pr-4 py-2 text-base hover:pl-2",
          topItem: "flex items-center text-sm px-4 border-r h-12",
          icon: "mr-3 text-lg"
        }
      };
      var subMenuStyles = {
        inline: {
          indicatorIcon: 'os-icon os-icon-arrow-down',
          subMenuWrapper: "ml-3 flex flex-col",
          subMenuParentWrapper: "flex flex-col"
        },
        flyout: {
          indicatorIcon: 'os-icon os-icon-arrow-right2',
          subMenuWrapper: "absolute ml-".concat(sizes[size].width - 8),
          subMenuParentWrapper: "flex flex-row",
          subMenuWrapperTop: "absolute top-full"
        }
      };
      return _objectSpread(_objectSpread({
        contentBg: "".concat(colors[color].contentBg),
        contentBgAccent: "".concat(colors[color].contentBgAccent),
        logoWrapper: "".concat(sizes[size].wrapper, " ").concat(colors[color].contentBgAccent, " ").concat(colors[color].textColorAccent),
        sidenavWrapper: "".concat(colors[color].contentBg, " ").concat(sizes[size].wrapper, " h-full hidden md:block z-20"),
        menuIconSide: "text-".concat(colors[color].accentColor, " ").concat(sizes[size].icon, " group-hover:").concat(colors[color].highlightColor),
        menuIconClosed: "fa fa-bars p-3 cursor-pointer",
        menuIconOpen: "fa fa-cancel",
        itemsWrapper: "p-4 border-t ".concat(colors[color].borderColor, " ").concat(sizes[size].wrapper),
        navitemSide: " \n\t            group font-sans flex flex-col\n\t            ".concat(sizes[size].sideItem, " ").concat(colors[color].textColor, " ").concat(colors[color].borderColor, " \n\t            hover:").concat(colors[color].highlightColor, " \n\t            focus:outline-none focus:text-gray-800 focus:bg-gray-50 focus:border-gray-300 \n\t            transition-all cursor-pointer\n\t         "),
        navitemSideActive: "\n\t            group font-sans flex flex-col w-full\n\t            ".concat(sizes[size].sideItem, " ").concat(colors[color].textColor, " ").concat(colors[color].borderColor, " \n\t            hover:").concat(colors[color].highlightColor, " \n\t            focus:outline-none focus:text-gray-800 focus:bg-gray-50 focus:border-gray-300 \n\t            transition-all cursor-pointer\n\t          ")
      }, subMenuStyles[subMenuStyle]), {}, {
        vars: {
          color: colors,
          size: sizes,
          subMenuStyle: subMenuStyles
        }
      });
    },

    /* -----
     Top Nav Theme Components Minimal
      ------*/
    topnav: function topnav() {
      var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var _opts$color2 = opts.color,
          color = _opts$color2 === void 0 ? 'white' : _opts$color2,
          _opts$size2 = opts.size,
          size = _opts$size2 === void 0 ? 'compact' : _opts$size2;
      var colors = {
        white: {
          contentBg: "bg-".concat(highlight),
          accentColor: "".concat(accent, "-600"),
          accentBg: "hover:bg-".concat(accent, "-600"),
          borderColor: "border-".concat(primary, "-100"),
          textColor: "text-".concat(primary, "-600"),
          highlightColor: "text-".concat(highlight)
        },
        bright: {
          contentBg: "bg-".concat(accent, "-700"),
          accentColor: "".concat(accent, "-400"),
          accentBg: "hover:bg-".concat(accent, "-400"),
          borderColor: "border-".concat(accent, "-600"),
          textColor: "text-".concat(highlight),
          highlightColor: "text-".concat(highlight)
        }
      };
      var sizes = {
        compact: {
          wrapper: "h-12",
          topItem: "flex items-center text-sm px-4 border-r h-12",
          icon: "mr-3 text-lg"
        },
        full: {
          wrapper: "h-16",
          topItem: "flex px-4 py-5 text-base font-light h-16",
          icon: "mr-4 -py-2 text-2xl"
        }
      };
      return {
        topnavWrapper: "w-full ".concat(colors[color].contentBg, " ").concat(sizes[size].wrapper, " "),
        topnavContent: "flex w-full h-full",
        topnavMenu: "hidden md:flex flex-1 h-full overflow-x-auto overflow-y-hidden scrollbar-sm",
        menuIconTop: "text-".concat(colors[color].accentColor, " ").concat(sizes[size].icon, " group-hover:").concat(colors[color].highlightColor),
        menuOpenIcon: "os-icon os-icon-menu",
        menuCloseIcon: "os-icon os-icon-x",
        navitemTop: "\n\t\t\t\t    group font-sans \n\t\t\t\t    ".concat(sizes[size].topItem, " ").concat(colors[color].textColor, " ").concat(colors[color].borderColor, " \n\t\t\t\t    ").concat(colors[color].accentBg, " hover:").concat(colors[color].highlightColor, " \n\t\t\t\t    focus:outline-none focus:text-gray-800 focus:bg-gray-50 focus:border-gray-300 \n\t\t\t\t    transition cursor-pointer\n\t\t\t\t"),
        //`px-4 text-sm font-medium tracking-widest uppercase inline-flex items-center  border-transparent  leading-5 text-white hover:bg-white hover:text-darkblue-500 border-gray-200 focus:outline-none focus:text-gray-700 focus:border-gray-300 transition duration-150 ease-in-out h-full`,
        topmenuRightNavContainer: "hidden md:block h-full",
        navitemTopActive: "\n\t\t\t\t\tgroup font-sans\n\t\t    \t\t".concat(sizes[size].topItem, " ").concat(colors[color].textColor, " ").concat(colors[color].borderColor, " \n\t\t    \t\t").concat(colors[color].accentBg, " hover:").concat(colors[color].highlightColor, " \n\t\t    \t\tfocus:outline-none focus:text-gray-800 focus:bg-gray-50 focus:border-gray-300 \n\t\t    \t\ttransition cursor-pointer\n\t\t    \t"),
        mobileButton: "md:hidden bg-white inline-flex items-center justify-center p-2  text-gray-400 hover:bg-gray-100 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-blue-300",
        vars: {
          color: colors,
          size: sizes
        }
      };
    },
    select: function select() {
      var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var _opts$color3 = opts.color,
          color = _opts$color3 === void 0 ? 'white' : _opts$color3,
          _opts$size3 = opts.size,
          size = _opts$size3 === void 0 ? 'full' : _opts$size3,
          _opts$wrapStyle = opts.wrapStyle,
          wrapStyle = _opts$wrapStyle === void 0 ? 'no-wrap' : _opts$wrapStyle;
      var colors = {
        white: 'white',
        transparent: 'gray-100'
      };
      var sizes = {
        mini: 'px-0 py-0',
        compact: 'px-0 py-1',
        full: 'px-4 py-2'
      };
      var wrapStyles = {
        'no-wrap': 'overflow-x-hidden',
        'wrap': 'whitespace-normal'
      };
      return {
        menuWrapper: "bg-".concat(colors[color], " my-1 text-sm"),
        menuItemActive: "px-2 py-2 cursor-not-allowed bg-".concat(accent, "-200 border-1 border-").concat(colors[color], " focus:border-").concat(accent, "-300"),
        menuItem: "px-2 py-2 cursor-pointer hover:bg-blue-100 border-1 border-".concat(colors[color], " focus:border-blue-300 flex-wrap"),
        valueItem: "max-w-full ".concat(wrapStyles[wrapStyle]),
        itemText: 'text-xl',
        select: "bg-".concat(colors[color], " w-full flex flex-1 flex-row justify-between truncate ").concat(sizes[size], " cursor-pointer border-2 border-").concat(colors[color], " focus:border-blue-300"),
        selectIcon: "self-center fa fa-angle-down text-gray-400 pt-2 px-2",
        vars: {
          color: colors,
          size: sizes,
          wrapStyle: wrapStyles
        }
      };
    },
    table: function table() {
      var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      console.log('hola', opts);
      var _opts$color4 = opts.color,
          color = _opts$color4 === void 0 ? 'white' : _opts$color4,
          _opts$size4 = opts.size,
          size = _opts$size4 === void 0 ? 'full' : _opts$size4;
      var colors = {
        white: 'bg-white hover:bg-gray-100',
        gray: 'bg-gray-100 hover:bg-gray-200',
        transparent: 'gray-100'
      };
      var sizes = {
        compact: 'px-4 py-1',
        full: 'px-10 py-5'
      };
      return {
        tableHeader: "".concat(sizes[size], " pb-1 border-b-2 border-gray-300 bg-gray-200 text-left font-medium text-gray-700 uppercase first:rounded-tl-md last:rounded-tr-md"),
        tableInfoBar: "bg-white",
        tableRow: "".concat(colors[color], " transition ease-in-out duration-150"),
        tableRowStriped: "bg-gray-100 even:bg-gray-200 hover:bg-gray-300 transition ease-in-out duration-150",
        tableCell: "".concat(sizes[size], " whitespace-no-wrap"),
        inputSmall: 'w-24',
        sortIconDown: 'fas fa-sort-amount-down',
        sortIconUp: 'fas fa-sort-amount-up',
        sortIconIdeal: 'fas fa-sort-alt',
        vars: {
          color: colors,
          size: sizes
        }
      };
    },
    tabpanel: function tabpanel() {
      var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var _opts$tabLocation = opts.tabLocation,
          tabLocation = _opts$tabLocation === void 0 ? 'top' : _opts$tabLocation;
      var tabLocations = {
        top: {
          tabpanelWrapper: 'flex-col',
          tabWrapper: 'flex-row',
          tab: "border-b-2"
        },
        left: {
          tabpanelWrapper: 'flex-row',
          tabWrapper: 'flex-col',
          tab: "border-r-2"
        }
      };
      return {
        tabpanelWrapper: "flex ".concat(tabLocations[tabLocation].tabpanelWrapper, " w-full h-full"),
        tabWrapper: "flex ".concat(tabLocations[tabLocation].tabWrapper),
        tab: "px-4 py-2 hover:text-gray-800 cursor-pointer   text-center text-gray-500",
        tabActive: "px-4 py-2 text-".concat(accent, "-500 ").concat(tabLocations[tabLocation].tab, " border-blue-500 text-center"),
        icon: '',
        tabName: '',
        contentWrapper: 'bg-white flex-1 h-full',
        vars: {
          tabLocation: tabLocations
        }
      };
    },
    button: function button() {
      var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var _opts$color5 = opts.color,
          color = _opts$color5 === void 0 ? 'white' : _opts$color5,
          _opts$size5 = opts.size,
          size = _opts$size5 === void 0 ? 'base' : _opts$size5,
          _opts$width = opts.width,
          width = _opts$width === void 0 ? 'block' : _opts$width;
      var colors = {
        white: "\n                    border border-gray-300  text-gray-700 bg-white hover:text-gray-500\n                    focus:outline-none focus:shadow-outline-blue focus:border-blue-300\n                    active:text-gray-800 active:bg-gray-50 transition duration-150 ease-in-out\n                    disabled:cursor-not-allowed\n                ",
        transparent: "\n                    border border-gray-300  text-gray-700 bg-white hover:text-gray-500\n                    focus:outline-none focus:shadow-outline-blue focus:border-blue-300\n                    active:text-gray-800 active:bg-gray-50 transition duration-150 ease-in-out\n                    disabled:cursor-not-allowed\n                ",
        primary: '',
        danger: ''
      };
      var sizes = {
        base: 'px-4 py-4 leading-5 font-medium',
        sm: 'text-sm px-2 py-2 leading-5 font-medium',
        lg: 'text-lg px-6 py-6 leading-5 font-medium',
        xl: 'text-2xl px-12 py-8 leading-5 font-medium'
      };
      var widths = {
        'block': '',
        'full': 'w-full'
      };
      return {
        button: "\n                    inline-flex items-center justify-items-center text-center\n                    ".concat(colors[color], " ").concat(sizes[size], " ").concat(widths[width], "\n                "),
        vars: {
          color: colors,
          size: sizes,
          width: widths
        }
      };
    },
    input: function input() {
      var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var _opts$color6 = opts.color,
          color = _opts$color6 === void 0 ? 'white' : _opts$color6,
          _opts$size6 = opts.size,
          size = _opts$size6 === void 0 ? 'small' : _opts$size6,
          _opts$width2 = opts.width,
          width = _opts$width2 === void 0 ? 'block' : _opts$width2;
      var colors = {
        white: 'bg-white',
        gray: 'bg-gray-100'
      };
      var sizes = {
        base: 'px-4 py-4 font-medium',
        small: 'text-sm px-2 py-2 font-medium text-xs',
        large: 'text-lg px-6 py-6 font-medium text-xl'
      };
      var widths = {
        'block': '',
        'full': 'w-full'
      };
      return {
        input: "\n                 ".concat(colors[color], " ").concat(sizes[size], " ").concat(widths[width], "\n                "),
        vars: {
          color: colors,
          size: sizes,
          width: widths
        }
      };
    },
    modal: function modal() {
      var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var _opts$size7 = opts.size,
          size = _opts$size7 === void 0 ? 'base' : _opts$size7,
          _opts$overlay = opts.overlay,
          overlay = _opts$overlay === void 0 ? 'default' : _opts$overlay;
      var overlays = {
        "default": 'fixed  inset-0 bg-gray-500 opacity-75',
        none: ''
      };
      var sizes = {
        base: 'sm:max-w-2xl',
        small: 'w-64',
        large: 'sm:max-w-4xl',
        xlarge: 'sm:max-w-8xl'
      };
      return {
        modalContainer: "".concat(overlay === 'default' ? '' : 'pointer-events-none', " fixed bottom-0 inset-x-0 px-4 pb-4 inset-0 flex items-center justify-center"),
        modalOverlay: overlays[overlay],
        modal: "".concat(sizes[size], "  pointer-events-auto bg-white rounded-lg overflow-hidden shadow-xl transform transition-all"),
        vars: {
          size: sizes,
          overlay: overlays
        }
      };
    },

    /* ------------------------- */
    shadow: "shadow",
    ySpace: "py-thing",
    text: "text-gray-800",
    textContrast: "text-white",
    border: "broder-gray-400",
    textInfo: "text-blue-400",
    bgInfo: "bg-blue-400",
    borderInfo: "border-blue-400",
    textSuccess: "text-blue-400",
    bgSuccess: "bg-blue-400",
    borderSuccess: "border-blue-400",
    textDanger: "text-red-400",
    bgDanger: "bg-red-400",
    borderDanger: "border-red-400",
    textWarning: "text-yellow-400",
    bgWarning: "bg-yellow-400",
    borderWarning: "border-yellow-400",
    textLight: "text-gray-400",
    // <-- for text styled like placeholder but can't be selected with ::placeholder
    placeholder: "placeholder-gray-400",
    topMenuBorder: "border-b border-gray-200",
    topMenuScroll: "",
    headerShadow: "",
    navText: "text-gray-100",
    navMenu: "h-full relative",
    navMenuOpen: "bg-darkblue-500 text-white shadow-lg w-56 rounded-t-lg",
    navMenuBg: "bg-darkblue-500 bb-rounded-10 shadow-lg text-white rounded-b-lg",
    navMenuItem: "hover:font-medium cursor-pointer px-2 py-1 text-lg font-semibold",
    bg: "bg-gray-50",
    menuBg: "bg-white z-50",
    menuBgHover: "",
    menuBgActive: "bg-blue-200",
    menuBgActiveHover: "hover:bg-blue-300",
    menuText: "text-gray-100",
    menuTextHover: "hover:text-gray-700",
    menuTextActive: "text-blue-500",
    menuTextActiveHover: "hover:text-blue-700",
    headerBg: "bg-gray-200",
    headerBgHover: "hover:bg-gray-400",
    inputBg: "bg-white disabled:bg-gray-200 cursor-pointer focus:outline-none",
    inputBorder: "rounded border-0 border-transparent hover:border-gray-300 focus:border-gray-600 disabled:border-gray-200",
    inputBgDisabled: "bg-gray-200 cursor-not-allowed focus:outline-none",
    inputBorderDisabled: "rounded border-2 border-gray-200 hover:border-gray-200",
    inputBgFocus: "bg-white cursor-pointer focus:outline-none",
    inputBorderFocus: "rounded border-2 border-transparent hover:border-gray-600 focus:border-gray-600 border-gray-600",
    textBase: "text-base",
    textSmall: "text-sm",
    textLarge: "text-lg",
    paddingBase: "py-1 px-2",
    paddingSmall: "py-0 px-1",
    paddingLarge: "py-2 px-4",
    contentBg: "bg-white",
    accent1: "bg-blue-100",
    accent2: "bg-gray-300",
    accent3: "bg-gray-400",
    accent4: "bg-gray-500",
    highlight1: "bg-blue-200",
    highlight2: "bg-blue-300",
    highlight3: "bg-blue-400",
    highlight4: "bg-blue-500",
    width: "",
    transition: "transition ease-in-out duration-150"
  };
};

var _default = avl_design;
exports["default"] = _default;