"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  useFalcor: true,
  FalcorConsumer: true,
  FalcorProvider: true,
  UPDATE: true,
  falcorReducer: true,
  updateFalcor: true,
  avlFalcor: true
};
exports.useFalcor = exports.updateFalcor = exports.falcorReducer = exports.avlFalcor = exports.UPDATE = exports.FalcorProvider = exports.FalcorConsumer = void 0;

var _react = _interopRequireDefault(require("react"));

var _lodash = _interopRequireDefault(require("lodash.debounce"));

var _lodash2 = _interopRequireDefault(require("lodash.get"));

var _falcorGraph = require("./falcorGraph");

Object.keys(_falcorGraph).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _falcorGraph[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _falcorGraph[key];
    }
  });
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var FalcorContext = /*#__PURE__*/_react["default"].createContext();

var useFalcor = function useFalcor() {
  return _react["default"].useContext(FalcorContext);
};

exports.useFalcor = useFalcor;
var FalcorConsumer = FalcorContext.Consumer;
exports.FalcorConsumer = FalcorConsumer;

var FalcorProvider = function FalcorProvider(_ref) {
  var falcor = _ref.falcor,
      children = _ref.children;

  var _React$useState = _react["default"].useState({}),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      falcorCache = _React$useState2[0],
      setFalcorCache = _React$useState2[1];

  var updateCache = _react["default"].useMemo(function () {
    return (0, _lodash["default"])(function () {
      var cache = falcor.getCache();
      setFalcorCache(cache);
    }, 250);
  }, [falcor]);

  _react["default"].useEffect(function () {
    falcor.onChange(updateCache);
    return function () {
      falcor.remove(updateCache);
    };
  }, [falcor, updateCache]);

  var falcorValue = _react["default"].useMemo(function () {
    return {
      falcor: falcor,
      falcorCache: falcorCache
    };
  }, [falcor, falcorCache]);

  return /*#__PURE__*/_react["default"].createElement(FalcorContext.Provider, {
    value: falcorValue
  }, children);
};

exports.FalcorProvider = FalcorProvider;
var UPDATE = 'avl-falcor/UPDATE';
exports.UPDATE = UPDATE;

var falcorReducer = function falcorReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments.length > 1 ? arguments[1] : undefined;

  switch (action.type) {
    case UPDATE:
      return _objectSpread({}, action.payload);

    default:
      return state;
  }
};

exports.falcorReducer = falcorReducer;

var updateFalcor = function updateFalcor(falcorCache) {
  return {
    type: UPDATE,
    payload: falcorCache
  };
};

exports.updateFalcor = updateFalcor;

var NO_MAP = function NO_MAP() {
  return {};
};

var NO_OP = function NO_OP() {};

var avlFalcor = function avlFalcor(Component) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var _options$mapCacheToPr = options.mapCacheToProps,
      mapCacheToProps = _options$mapCacheToPr === void 0 ? NO_MAP : _options$mapCacheToPr;
  return function (props) {
    var _React$useState3 = _react["default"].useState(),
        _React$useState4 = _slicedToArray(_React$useState3, 2),
        ref = _React$useState4[0],
        setRef = _React$useState4[1];

    var _useFalcor = useFalcor(),
        falcor = _useFalcor.falcor,
        falcorCache = _useFalcor.falcorCache;

    _react["default"].useEffect(function () {
      if (!ref) return;
      if (typeof ref.fetchFalcorDeps !== "function") return;
      ref.fetchFalcorDeps(falcorCache).then(NO_OP);
    }, [ref, falcorCache]);

    return /*#__PURE__*/_react["default"].createElement(Component, _extends({}, props, {
      ref: setRef,
      falcor: falcor,
      falcorCache: falcorCache
    }, mapCacheToProps(falcorCache, props)));
  };
};

exports.avlFalcor = avlFalcor;