"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PressListItem = exports.ListItemRemovable = exports.List = exports.EndorsementListItem = void 0;

var _react = _interopRequireDefault(require("react"));

require("styles/tailwind.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var noop = function noop() {};

var ListItemRemovable = function ListItemRemovable(_ref) {
  var item = _ref.item,
      _ref$remove = _ref.remove,
      remove = _ref$remove === void 0 ? noop : _ref$remove;
  return /*#__PURE__*/_react["default"].createElement("li", null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "hover:bg-gray-50 focus:outline-none focus:bg-gray-50 transition duration-150 ease-in-out"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex items-center px-4 py-4 sm:px-6"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "min-w-0 flex-1 flex items-center"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "min-w-0 flex-1 px-4 md:grid md:grid-cols-1 md:gap-4"
  }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "text-lg leading-5 font-dark text-gray-600 truncate"
  }, item)))), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("svg", {
    className: "h-5 w-5 text-gray-400 hover:text-red-400",
    fill: "currentColor",
    viewBox: "0 0 20 20",
    onClick: remove
  }, /*#__PURE__*/_react["default"].createElement("path", {
    fillRule: "evenodd",
    d: "M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z",
    clipRule: "evenodd"
  }))))));
};

exports.ListItemRemovable = ListItemRemovable;

var EndorsementListItem = function EndorsementListItem(_ref2, i) {
  var name = _ref2.name,
      role = _ref2.role,
      quote = _ref2.quote,
      remove = _ref2.remove;
  return /*#__PURE__*/_react["default"].createElement("li", {
    key: i
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "hover:bg-gray-50 transition duration-150 ease-in-out"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex items-center px-4 py-4 sm:px-6"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "min-w-0 flex-1 flex items-center"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "min-w-0 flex-1 px-4 md:grid md:grid-cols-1 md:gap-4"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: ""
  }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "text-sm leading-5 text-gray-600"
  }, quote), /*#__PURE__*/_react["default"].createElement("div", {
    className: "mt-2 flex items-center text-lg leading-5 text-gray-800"
  }, name), /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex items-center text-md leading-5 text-blue-400"
  }, role))))), remove ? /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("svg", {
    onClick: remove,
    className: "h-5 w-5 text-gray-400 hover:text-red-400",
    fill: "currentColor",
    viewBox: "0 0 20 20"
  }, /*#__PURE__*/_react["default"].createElement("path", {
    fillRule: "evenodd",
    d: "M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z",
    clipRule: "evenodd"
  }))) : '')));
};

exports.EndorsementListItem = EndorsementListItem;

var PressListItem = function PressListItem(_ref3, i) {
  var title = _ref3.title,
      publication = _ref3.publication,
      url = _ref3.url,
      remove = _ref3.remove;
  return /*#__PURE__*/_react["default"].createElement("li", {
    key: i
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "hover:bg-gray-50 transition duration-150 ease-in-out"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex items-center px-4 py-4 sm:px-6"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "min-w-0 flex-1 flex items-center"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "min-w-0 flex-1 px-4 md:grid md:grid-cols-1 md:gap-4"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: ""
  }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "text-sm leading-5 text-gray-600"
  }, title), url.length > 0 ? /*#__PURE__*/_react["default"].createElement("div", {
    className: "mt-2 flex items-center text-lg leading-5 text-gray-800"
  }, publication) : /*#__PURE__*/_react["default"].createElement("div", {
    className: "mt-2 flex items-center text-lg leading-5 text-gray-800"
  }, /*#__PURE__*/_react["default"].createElement("a", {
    href: url,
    target: "_blank",
    rel: "noopener noreferrer"
  }, " ", publication, " ")))))), remove ? /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("svg", {
    onClick: remove,
    className: "h-5 w-5 text-gray-400 hover:text-red-400",
    fill: "currentColor",
    viewBox: "0 0 20 20"
  }, /*#__PURE__*/_react["default"].createElement("path", {
    fillRule: "evenodd",
    d: "M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z",
    clipRule: "evenodd"
  }))) : '')));
};

exports.PressListItem = PressListItem;

var List = function List(_ref4) {
  var children = _ref4.children;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "bg-white overflow-hidden sm:rounded-md"
  }, /*#__PURE__*/_react["default"].createElement("ul", null, children));
};

exports.List = List;