"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

// import { useTheme } from "../../wrappers/with-theme"
var Dropdown = function Dropdown(_ref) {
  var control = _ref.control,
      children = _ref.children,
      className = _ref.className,
      _ref$openType = _ref.openType,
      openType = _ref$openType === void 0 ? 'hover' : _ref$openType;

  var _React$useState = _react["default"].useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      open = _React$useState2[0],
      setOpen = _React$useState2[1],
      clickedOutside = _react["default"].useCallback(function () {
    return setOpen(false);
  }, []),
      _useClickOutside = (0, _utils.useClickOutside)(clickedOutside),
      _useClickOutside2 = _slicedToArray(_useClickOutside, 1),
      setRef = _useClickOutside2[0]; // console.log('openType', openType)


  return /*#__PURE__*/_react["default"].createElement("div", {
    ref: setRef,
    className: "h-full relative cursor-pointer ".concat(className),
    onMouseEnter: function onMouseEnter(e) {
      if (openType === 'hover') {
        setOpen(true);
      }
    },
    onMouseLeave: function onMouseLeave(e) {
      return setOpen(false);
    },
    onClick: function onClick(e) {
      //e.preventDefault();
      setOpen(!open);
    }
  }, control, open ? /*#__PURE__*/_react["default"].createElement("div", {
    className: "shadow fixed w-full max-w-[200px] rounded-b-lg ".concat(open ? "block" : "hidden", " z-10")
  }, children) : '');
};

var _default = Dropdown;
exports["default"] = _default;