"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Select = _interopRequireDefault(require("./Select"));

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

//import { useTheme } from "../../wrappers";
var Identity = function Identity(i) {
  return i;
};

var _default = {
  name: "Select",
  themeVar: 'select',
  description: "Select component supports, multi, search ",
  props: [{
    name: "multi",
    "default": true,
    type: "Boolean"
  }, {
    name: "searchable",
    "default": true,
    type: "Boolean"
  }, {
    name: "domain",
    "default": [],
    type: "Array"
  }, {
    name: "options",
    "default": [],
    type: "Array"
  }, {
    name: "value",
    "default": null,
    type: "String"
  }, {
    name: "placeholder",
    "default": "Select a value...",
    type: "String"
  }, {
    name: "accessor",
    "default": Identity,
    type: "Boolean"
  }, {
    name: "valueAccessor",
    "default": Identity,
    type: "Boolean"
  }, {
    name: "displayAccessor",
    "default": null,
    type: "Function"
  }, {
    name: "listAccessor",
    "default": null,
    type: "Function"
  }, {
    name: "id",
    "default": "avl-select",
    type: "String"
  }, {
    name: "autoFocus",
    "default": false,
    type: "Boolean"
  }, {
    name: "disabled",
    "default": false,
    type: "Boolean"
  }, {
    name: "removable",
    "default": true,
    type: "Boolean"
  }],
  examples: [{
    title: 'Simple Select',
    props: [{
      name: "options",
      "default": ["Afghanistan", "Albania", "Algeria", "Andorra", "Angola", "Antigua", "Argentina", "Armenia", "Australia", "Austria", "Really long selection to test what happens when something like this is selected"]
    }],
    Component: function Component(props) {
      var _React$useState = _react["default"].useState(''),
          _React$useState2 = _slicedToArray(_React$useState, 2),
          selected = _React$useState2[0],
          setSelected = _React$useState2[1];

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "h-full w-full bg-gray-100"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "w-40 mx-auto py-12"
      }, "Select:", /*#__PURE__*/_react["default"].createElement(_Select["default"], _extends({}, props, {
        value: selected,
        onChange: function onChange(v) {
          return setSelected(v);
        },
        className: "text-5xl"
      }))));
    }
  }, {
    title: 'Multi Select',
    props: [{
      name: "options",
      "default": ["Afghanistan", "Albania", "Algeria", "Andorra", "Angola", "Antigua", "Argentina", "Armenia", "Australia", "Austria", "Really long selection to test what happens when something like this is selected"]
    }, {
      name: "multi",
      "default": true
    }, {
      name: "removable",
      "default": true
    }],
    Component: function Component(props) {
      var _React$useState3 = _react["default"].useState(''),
          _React$useState4 = _slicedToArray(_React$useState3, 2),
          selected = _React$useState4[0],
          setSelected = _React$useState4[1];

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "h-full w-full bg-gray-100"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "w-72 mx-auto py-12"
      }, "Select:", /*#__PURE__*/_react["default"].createElement(_Select["default"], _extends({}, props, {
        value: selected,
        onChange: function onChange(v) {
          return setSelected(v);
        },
        className: ""
      }))));
    }
  }]
};
exports["default"] = _default;