"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ValueItem = void 0;

var _react = _interopRequireWildcard(require("react"));

var _input = _interopRequireDefault(require("./input"));

var _utils = require("./utils");

var _parts = require("./parts");

var _withTheme = require("../../wrappers/with-theme");

var _deepEqual = _interopRequireDefault(require("deep-equal"));

var _lodash = _interopRequireDefault(require("lodash.get"));

var _matchSorter = require("match-sorter");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ValueItem = function ValueItem(_ref) {
  var isPlaceholder = _ref.isPlaceholder,
      children = _ref.children,
      remove = _ref.remove,
      edit = _ref.edit,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled;

  var theme = _objectSpread({}, (0, _withTheme.useTheme)());

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "\n        ".concat(isPlaceholder ? theme.textLight : "".concat(disabled ? theme.accent2 : !(remove || edit) ? "" : theme.menuBgActive, "\n            mr-1 pl-2 ").concat(!disabled && (remove || edit) ? "pr-1" : "pr-4", "\n          "), "\n        ").concat(theme.itemText, "\n         mt-1 flex items-center max-w-full\n      ")
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "max-w-full"
  }, children), isPlaceholder || disabled || !edit ? null : /*#__PURE__*/_react["default"].createElement("div", {
    className: "\n            ".concat(theme.menuBgActive, " ").concat(theme.menuBgActiveHover, " ").concat(theme.textContrast, "\n            ml-2 p-1 flex justify-center items-center rounded cursor-pointer\n          "),
    onClick: edit
  }, /*#__PURE__*/_react["default"].createElement("svg", {
    width: "8",
    height: "8"
  }, /*#__PURE__*/_react["default"].createElement("line", {
    x1: "0",
    y1: "6",
    x2: "4",
    y2: "2",
    style: {
      stroke: "currentColor",
      strokeWidth: 2
    }
  }), /*#__PURE__*/_react["default"].createElement("line", {
    x1: "4",
    y1: "2",
    x2: "8",
    y2: "6",
    style: {
      stroke: "currentColor",
      strokeWidth: 2
    }
  }))), isPlaceholder || disabled || !remove ? null : /*#__PURE__*/_react["default"].createElement("div", {
    className: "\n            ".concat(theme.menuBgActive, " ").concat(theme.menuBgActiveHover, " ").concat(theme.textContrast, "\n            ").concat(edit ? "ml-1" : "ml-2", " p-1 flex justify-center items-center rounded cursor-pointer\n          "),
    onClick: remove
  }, /*#__PURE__*/_react["default"].createElement("svg", {
    width: "8",
    height: "8"
  }, /*#__PURE__*/_react["default"].createElement("line", {
    x2: "8",
    y2: "8",
    style: {
      stroke: "currentColor",
      strokeWidth: 2
    }
  }), /*#__PURE__*/_react["default"].createElement("line", {
    y1: "8",
    x2: "8",
    style: {
      stroke: "currentColor",
      strokeWidth: 2
    }
  }))));
};

exports.ValueItem = ValueItem;

var Dropdown = /*#__PURE__*/_react["default"].forwardRef(function (_ref2, ref) {
  var children = _ref2.children,
      searchable = _ref2.searchable,
      opened = _ref2.opened,
      direction = _ref2.direction,
      _ref2$themeOptions = _ref2.themeOptions,
      themeOptions = _ref2$themeOptions === void 0 ? {} : _ref2$themeOptions;
  var theme = (0, _withTheme.useTheme)()['select'](themeOptions);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "\n      absolute left-0 z-40 overflow-hidden min-w-full\n      ".concat(opened ? "block" : "hidden", "\n    "),
    style: direction === "down" ? {
      top: "100%"
    } : {
      bottom: "100%"
    },
    ref: ref
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(theme.menuWrapper)
  }, children));
});

var DropdownItem = function DropdownItem(_ref3) {
  var children = _ref3.children,
      isActive = _ref3.isActive,
      _ref3$themeOptions = _ref3.themeOptions,
      themeOptions = _ref3$themeOptions === void 0 ? {} : _ref3$themeOptions,
      props = _objectWithoutProperties(_ref3, ["children", "isActive", "themeOptions"]);

  var theme = (0, _withTheme.useTheme)()['select'](themeOptions);
  return /*#__PURE__*/_react["default"].createElement("div", _extends({}, props, {
    className: "\n        ".concat(isActive ? "".concat(theme.menuItemActive) : "".concat(theme.menuItem), "\n      ")
  }), children);
};

var Identity = function Identity(i) {
  return i;
};

var Select = function Select(props) {
  var _props$multi = props.multi,
      multi = _props$multi === void 0 ? false : _props$multi,
      _props$searchable = props.searchable,
      searchable = _props$searchable === void 0 ? false : _props$searchable,
      _props$domain = props.domain,
      domain = _props$domain === void 0 ? [] : _props$domain,
      _props$options = props.options,
      options = _props$options === void 0 ? [] : _props$options,
      _props$value = props.value,
      value = _props$value === void 0 ? null : _props$value,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? "Select a value..." : _props$placeholder,
      _props$accessor = props.accessor,
      accessor = _props$accessor === void 0 ? Identity : _props$accessor,
      _props$displayAccesso = props.displayAccessor,
      displayAccessor = _props$displayAccesso === void 0 ? null : _props$displayAccesso,
      _props$listAccessor = props.listAccessor,
      listAccessor = _props$listAccessor === void 0 ? null : _props$listAccessor,
      _props$id = props.id,
      id = _props$id === void 0 ? "avl-select" : _props$id,
      _props$autoFocus = props.autoFocus,
      autoFocus = _props$autoFocus === void 0 ? false : _props$autoFocus,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$removable = props.removable,
      removable = _props$removable === void 0 ? false : _props$removable,
      _props$themeOptions = props.themeOptions,
      themeOptions = _props$themeOptions === void 0 ? {} : _props$themeOptions,
      _props$onChange = props.onChange,
      onChange = _props$onChange === void 0 ? Identity : _props$onChange,
      _props$valueAccessor = props.valueAccessor,
      valueAccessor = _props$valueAccessor === void 0 ? Identity : _props$valueAccessor,
      _props$className = props.className,
      className = _props$className === void 0 ? '' : _props$className;
  var theme = (0, _withTheme.useTheme)()['select'](themeOptions);

  var node = _react["default"].useRef();

  var vcNode = _react["default"].useRef();

  var dropdown = _react["default"].useRef();

  var optionRefs = _react["default"].useRef(new Array());

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      opened = _useState2[0],
      setOpened = _useState2[1];

  var _useState3 = (0, _react.useState)('down'),
      _useState4 = _slicedToArray(_useState3, 2),
      direction = _useState4[0],
      setDirection = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      hasFocus = _useState6[0],
      setHasFocus = _useState6[1];

  var _useState7 = (0, _react.useState)(''),
      _useState8 = _slicedToArray(_useState7, 2),
      search = _useState8[0],
      setSearch = _useState8[1];

  var _useState9 = (0, _react.useState)(false),
      _useState10 = _slicedToArray(_useState9, 2),
      optionFocus = _useState10[0],
      setOptionFocus = _useState10[1];

  var checkOutside = function checkOutside(e) {
    if (node && node.current && node.current.contains(e.target)) {
      return;
    }

    closeDropdown();
  };

  var openDropdown = function openDropdown(e) {
    e.stopPropagation();
    setOpened(true);
    setHasFocus(true);
  };

  var closeDropdown = function closeDropdown(e) {
    opened && vcNode && vcNode.current.focus();
    setOpened(false);
  };

  var focus = function focus() {
    vcNode && vcNode.focus();
  };

  (0, _react.useEffect)(function () {
    autoFocus && focus();
  }, []);
  (0, _react.useEffect)(function () {
    document.addEventListener("mousedown", checkOutside);

    if (dropdown && dropdown.current && opened && direction === "down") {
      var rect = dropdown.current.getBoundingClientRect();

      if (rect.top + rect.height > window.innerHeight) {
        setDirection("up");
      }
    }

    return function () {
      document.removeEventListener("mousedown", checkOutside);
    };
  }, []);
  /*componentWillUnmount() {
    
  }*/

  var getValues = function getValues() {
    var values = [];
    if (!(0, _utils.hasValue)(value)) return [];

    if (!Array.isArray(value)) {
      values = [value];
    } else {
      values = value;
    }

    return getOptions().filter(function (option) {
      // return values.includes(this.props.valueAccessor(option));
      return values.reduce(function (a, c) {
        return a || (0, _deepEqual["default"])(valueAccessor(option), c);
      }, false);
    });
  };

  var addItem = function addItem(e, v) {
    e.stopPropagation();
    closeDropdown();
    v = valueAccessor(v);

    if (multi) {
      if (!(0, _utils.hasValue)(value)) {
        onChange([v]);
      } else if (value.reduce(function (a, c) {
        return a && !(0, _deepEqual["default"])(c, v);
      }, true)) {
        onChange([].concat(_toConsumableArray(value), [v]));
      }
    } else {
      onChange(v);
    }
  };

  var removeItem = function removeItem(e, v) {
    e.stopPropagation();
    v = valueAccessor(v);

    if (multi) {
      onChange(value.filter(function (d) {
        return !(0, _deepEqual["default"])(d, v);
      }));
    } else {
      onChange(null);
    }
  };

  var getOptions = function getOptions() {
    return options.length ? options : domain;
  };

  var handleKeyDown = (0, _react.useCallback)(function (e) {
    switch (e.key) {
      // Ref: https://www.w3.org/TR/wai-aria-practices-1.2/#keyboard-interaction-13
      case 'Space':
      case 'Enter':
      case 'ArrowDown':
        e.preventDefault();

        if (!opened) {
          setOpened(true);
        }

        console.log('set option focus', optionRefs);

        if (optionRefs[0] && optionRefs[0].current) {
          optionRefs[0].current.focus();
        } // d.nextFrame(() => {
        //   if (!state.propsRef.current.value)
        //     dispatch({ type: ActionTypes.GoToOption, focus: Focus.First })
        // })


        break;

      case 'ArrowUp':
        e.preventDefault();

        if (!opened) {
          setOpened(true);
        }

        if (optionRefs[0] && optionRefs[0].current) {
          console.log('set option focus', optionRefs[0].current, optionRefs);
          optionRefs[0].current.focus();
        }

        break;

      case 'Escape':
        e.preventDefault();
        e.stopPropagation();

        if (opened) {
          setOpened(false);
        }

        break;
      // case 'Tab':
      //   e.preventDefault()
      //   e.stopPropagation()
      //   break
    }
  }, [opened]);
  var values = getValues();

  var _options = getOptions();

  var activeOptions = _options.filter(function (d) {
    return values.includes(d);
  });

  var uselistAccessor = listAccessor || accessor;
  var viewOptions = !search ? _options : (0, _matchSorter.matchSorter)(_options, search, {
    keys: [uselistAccessor]
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    ref: node,
    onMouseLeave: function onMouseLeave(e) {
      return closeDropdown();
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "cursor-pointer"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    id: props.id,
    ref: vcNode,
    onBlur: function onBlur(e) {
      return setHasFocus(false);
    },
    onFocus: function onFocus(e) {
      return setHasFocus(true);
    },
    onKeyDown: handleKeyDown,
    disabled: disabled,
    tabIndex: disabled ? -1 : 0,
    onClick: openDropdown,
    className: "".concat(theme.select, " ").concat(className)
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex-1 flex flex-wrap max-w-full"
  }, values.length ? values.map(function (v, i, a) {
    return /*#__PURE__*/_react["default"].createElement(ValueItem, {
      key: i,
      disabled: disabled,
      themeOptions: themeOptions,
      remove: removable ? function (e) {
        return removeItem(e, v);
      } : null
    }, accessor(v, a));
  }) : /*#__PURE__*/_react["default"].createElement(ValueItem, {
    key: "placeholder",
    isPlaceholder: true
  }, placeholder)), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(theme.selectIcon)
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "relative"
  }, disabled || !opened ? null : /*#__PURE__*/_react["default"].createElement(Dropdown, {
    opened: opened,
    direction: direction,
    searchable: searchable,
    ref: dropdown,
    themeOptions: themeOptions
  }, !searchable ? null : /*#__PURE__*/_react["default"].createElement("div", {
    className: "p-2 pt-1 w-full"
  }, /*#__PURE__*/_react["default"].createElement(_input["default"], {
    type: "text",
    autoFocus: true,
    placeholder: "search...",
    className: "w-full",
    value: search,
    onChange: function onChange(v) {
      return setSearch(v);
    }
  })), !viewOptions.length ? /*#__PURE__*/_react["default"].createElement("div", {
    className: "p-1 text-center"
  }, "No Selections") : /*#__PURE__*/_react["default"].createElement("div", {
    className: "scrollbar overflow-y-auto",
    style: {
      maxHeight: "15rem"
    }
  }, viewOptions.map(function (d, i) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      ref: function ref(element) {
        return optionRefs.current.push(element);
      },
      key: "".concat(accessor(d), "-").concat(i),
      onClick: activeOptions.includes(d) ? function (e) {
        return e.stopPropagation();
      } : function (e) {
        return addItem(e, d);
      },
      className: "".concat(activeOptions.includes(d) ? "".concat(theme.menuItemActive) : "".concat(theme.menuItem))
    }, (0, _lodash["default"])(d, "OptionComponent") ? /*#__PURE__*/_react["default"].createElement(d.OptionComponent, {
      option: d
    }) : uselistAccessor(d));
  })))));
};

var _default = Select;
exports["default"] = _default;