"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Button = require("../Button");

var _input = _interopRequireDefault(require("./input"));

var _parts = require("./parts");

var _utils = require("./utils");

var _excluded = ["verify", "id", "autoFocus"],
    _excluded2 = ["value", "type", "disabled"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var _default = function _default(_ref) {
  var verify = _ref.verify,
      id = _ref.id,
      autoFocus = _ref.autoFocus,
      props = _objectWithoutProperties(_ref, _excluded);

  var _useState = (0, _react.useState)(""),
      _useState2 = _slicedToArray(_useState, 2),
      newValue = _useState2[0],
      setValue = _useState2[1],
      _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      buttonDisabled = _useState4[0],
      setDisabled = _useState4[1];

  var value = props.value,
      type = props.type,
      disabled = props.disabled,
      rest = _objectWithoutProperties(props, _excluded2);

  var node = null;

  var addToArray = function addToArray() {
    var asArray = value || [];
    props.onChange([].concat(_toConsumableArray(asArray), [newValue]));
    setValue("");
    node && node.focus();
  };

  var removeFromArray = function removeFromArray(v) {
    var value = Array.isArray(props.value) ? props.value : [];

    if (value.includes(v)) {
      value = value.filter(function (vv) {
        return vv !== v;
      });
    }

    if (value.length === 0) {
      value = null;
    }

    props.onChange(value);
  };

  var _edit = function edit(v) {
    setValue(v);
    removeFromArray(v);
    node && node.focus();
  };

  (0, _react.useEffect)(function () {
    setDisabled(disabled || !(0, _utils.hasValue)(newValue) || (value || []).includes(newValue) || !(0, _utils.verifyValue)(newValue, type, verify) || type === "number" && !(value || []).reduce(function (a, c) {
      return a && +c !== +newValue;
    }, true));
  }, [value, newValue, verify, disabled, type]);

  var onKeyDown = function onKeyDown(e) {
    if (newValue && e.keyCode === 13) {
      e.stopPropagation();
      e.preventDefault();
      addToArray();
    }
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "w-full"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex"
  }, /*#__PURE__*/_react["default"].createElement(_input["default"], _extends({}, rest, {
    type: type,
    className: "mr-1",
    onKeyDown: onKeyDown,
    value: newValue,
    id: id,
    onChange: function onChange(v) {
      return setValue(v);
    },
    disabled: disabled,
    autoFocus: autoFocus,
    placeholder: "Type a value...",
    ref: function ref(n) {
      node = n;
    }
  })), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    onClick: function onClick(e) {
      return addToArray();
    },
    buttonTheme: "buttonInfo",
    disabled: buttonDisabled
  }, "add")), !value ? null : /*#__PURE__*/_react["default"].createElement("div", {
    className: "mt-1 ml-10"
  }, /*#__PURE__*/_react["default"].createElement(_parts.ValueContainer, {
    className: "cursor-default"
  }, value.map(function (v, i) {
    return /*#__PURE__*/_react["default"].createElement(_parts.ValueItem, {
      key: v,
      edit: function edit(e) {
        return _edit(v);
      },
      remove: function remove(e) {
        return removeFromArray(v);
      }
    }, v);
  }))));
};

exports["default"] = _default;