"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var FlyoutMenu = function FlyoutMenu(_ref) {
  var open = _ref.open,
      items = _ref.items,
      bottomItems = _ref.bottomItems;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "absolute  inset-x-0 transform shadow-lg z-50 ".concat(open ? '' : 'hidden')
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "bg-white"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "max-w-7xl mx-auto grid gap-y-6 px-4 py-6 sm:grid-cols-2 sm:gap-8 sm:px-6 sm:py-8 lg:grid-cols-4 lg:px-8 lg:py-12 xl:py-16"
  }, items.map(function (item, i) {
    return /*#__PURE__*/_react["default"].createElement("a", {
      href: "".concat(item.href),
      key: i,
      className: "-m-3 p-3 flex flex-col justify-between rounded-lg hover:bg-gray-50 transition ease-in-out duration-150"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "flex md:h-full lg:flex-col"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "flex-shrink-0"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "inline-flex text-2xl items-center justify-center h-10 w-10 rounded-md bg-blue-500 text-white sm:h-12 sm:w-12"
    }, /*#__PURE__*/_react["default"].createElement("i", {
      className: item.icon
    }))), /*#__PURE__*/_react["default"].createElement("div", {
      className: "ml-4 md:flex-1 md:flex md:flex-col md:justify-between lg:ml-0 lg:mt-4"
    }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("p", {
      className: "text-base font-medium text-gray-900"
    }, item.title), /*#__PURE__*/_react["default"].createElement("p", {
      className: "mt-1 text-sm text-gray-500"
    }, item.description)), /*#__PURE__*/_react["default"].createElement("p", {
      className: "mt-2 text-sm font-medium text-blue-600 lg:mt-4"
    }, "Learn more ", /*#__PURE__*/_react["default"].createElement("span", {
      "aria-hidden": "true"
    }, "\u2192")))));
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "bg-gray-50"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "max-w-7xl mx-auto space-y-6 px-4 py-1 sm:flex sm:space-y-0 sm:space-x-10 sm:px-6 lg:px-8"
  }, bottomItems.map(function (item, i) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: i,
      className: "flow-root"
    }, item);
  }))));
};

var _default = FlyoutMenu;
exports["default"] = _default;