"use strict";

var _react = _interopRequireDefault(require("react"));

var _withTheme = require("../../wrappers/with-theme");

var _excluded = ["children", "isActive", "customTheme"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Menu = /*#__PURE__*/_react["default"].forwardRef(function (_ref, ref) {
  var children = _ref.children,
      searchable = _ref.searchable,
      opened = _ref.opened,
      direction = _ref.direction,
      customTheme = _ref.customTheme;
  var theme = (0, _withTheme.useTheme)();
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(opened ? "block" : "hidden", " absolute left-0 z-40 overflow-hidden w-full"),
    style: direction === "down" ? {
      top: "100%"
    } : {
      bottom: "100%"
    },
    ref: ref
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(theme.accent3, " my-1 ").concat(searchable ? "pt-1" : "")
  }, children));
});

var MenuItem = function MenuItem(_ref2) {
  var children = _ref2.children,
      isActive = _ref2.isActive,
      customTheme = _ref2.customTheme,
      props = _objectWithoutProperties(_ref2, _excluded);

  var theme = (0, _withTheme.useTheme)();
  return /*#__PURE__*/_react["default"].createElement("div", _extends({}, props, {
    className: "\n        px-2 whitespace-no-wrap\n        ".concat(theme.itemText, "\n        ").concat(isActive ? "cursor-not-allowed ".concat(theme.accent2) : "cursor-pointer hover:".concat(theme.accent2), "\n      ")
  }), children);
};