"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Modal = _interopRequireDefault(require("./Modal"));

var _Button = require("../Button");

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

//import { useTheme } from "../../wrappers";
var Identity = function Identity(i) {
  return i;
};

var _default = {
  name: "Modal",
  themeVar: 'modal',
  description: "It pops up and then goes back to where it came",
  props: [{
    name: "open",
    "default": false,
    type: "Boolean"
  }],
  examples: [{
    title: 'Simple',
    props: [{
      name: "open",
      "default": false
    }],
    Component: function Component(props) {
      var _React$useState = _react["default"].useState(false),
          _React$useState2 = _slicedToArray(_React$useState, 2),
          open = _React$useState2[0],
          toggle = _React$useState2[1];

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "h-full w-full bg-gray-100"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "max-w-5xl mx-auto py-12"
      }, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
        onClick: function onClick(e) {
          return toggle(!open);
        }
      }, " Toggle "), /*#__PURE__*/_react["default"].createElement(_Modal["default"], _extends({}, props, {
        open: open
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "p-6"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: ""
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "mx-auto flex items-center justify-center h-12 w-12 rounded-full bg-green-100"
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: " fa fa-check",
        "aria-hidden": "true"
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "mt-3 text-center sm:mt-5"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        as: "h3",
        className: "text-lg leading-6 font-medium text-gray-900"
      }, "Payment successful"), /*#__PURE__*/_react["default"].createElement("div", {
        className: "mt-2"
      }, /*#__PURE__*/_react["default"].createElement("p", {
        className: "text-sm text-gray-500"
      }, "Lorem ipsum, dolor sit amet consectetur adipisicing elit. Eius aliquam laudantium explicabo pariatur iste dolorem animi vitae error totam. At sapiente aliquam accusamus facere veritatis.")))), /*#__PURE__*/_react["default"].createElement("div", {
        className: "mt-5 sm:mt-6 sm:grid sm:grid-cols-2 sm:gap-3 sm:grid-flow-row-dense"
      }, /*#__PURE__*/_react["default"].createElement("button", {
        type: "button",
        className: "w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-indigo-600 text-base font-medium text-white hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 sm:col-start-2 sm:text-sm",
        onClick: function onClick() {
          return toggle(false);
        }
      }, "Deactivate"), /*#__PURE__*/_react["default"].createElement("button", {
        type: "button",
        className: "mt-3 w-full inline-flex justify-center rounded-md border border-gray-300 shadow-sm px-4 py-2 bg-white text-base font-medium text-gray-700 hover:bg-gray-50 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 sm:mt-0 sm:col-start-1 sm:text-sm",
        onClick: function onClick() {
          return toggle(false);
        }
      }, "Cancel"))))));
    }
  }]
};
exports["default"] = _default;