"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactRouterDom = require("react-router-dom");

var _Icons = _interopRequireDefault(require("../Icons"));

var _wrappers = require("../../wrappers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var NavItem = function NavItem(_ref) {
  var children = _ref.children,
      icon = _ref.icon,
      to = _ref.to,
      _onClick = _ref.onClick,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? null : _ref$className,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? "side" : _ref$type,
      _ref$active = _ref.active,
      active = _ref$active === void 0 ? false : _ref$active,
      _ref$subMenus = _ref.subMenus,
      subMenus = _ref$subMenus === void 0 ? [] : _ref$subMenus,
      themeOptions = _ref.themeOptions,
      _ref$subMenuActivate = _ref.subMenuActivate,
      subMenuActivate = _ref$subMenuActivate === void 0 ? 'onClick' : _ref$subMenuActivate,
      _ref$subMenuOpen = _ref.subMenuOpen,
      subMenuOpen = _ref$subMenuOpen === void 0 ? false : _ref$subMenuOpen;
  // console.log('renderMenu')
  var theme = (0, _wrappers.useTheme)()[type === 'side' ? 'sidenav' : 'topnav'](themeOptions);
  var history = (0, _reactRouterDom.useHistory)();

  var To = _react["default"].useMemo(function () {
    if (!Array.isArray(to)) {
      return [to];
    }

    return to;
  }, [to]);

  var subTos = _react["default"].useMemo(function () {
    var subs = subMenus.reduce(function (a, c) {
      if (Array.isArray(c.path)) {
        a.push.apply(a, _toConsumableArray(c.path));
      } else if (c.path) {
        a.push(c.path);
      }

      return a;
    }, []);
    return [].concat(_toConsumableArray(To), _toConsumableArray(subs));
  }, [To, subMenus]);

  var routeMatch = Boolean((0, _reactRouterDom.useRouteMatch)({
    path: subTos,
    exact: true
  }));
  var linkClasses = type === "side" ? theme.navitemSide : theme.navitemTop;
  var activeClasses = type === "side" ? theme.navitemSideActive : theme.navitemTopActive;
  var navClass = routeMatch || active ? activeClasses : linkClasses;

  var _React$useState = _react["default"].useState(subMenuOpen || routeMatch),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      showSubMenu = _React$useState2[0],
      setShowSubMenu = _React$useState2[1];

  (0, _react.useEffect)(function () {
    // check when the component is loaded
    var localStorageToggled = localStorage.getItem("".concat(to, "_toggled")); // If is not null

    if (localStorageToggled) {
      setShowSubMenu(localStorageToggled === "true" || routeMatch ? true : false);
    } else {
      // If null set the localStorage key/value as a string.
      localStorage.setItem("".concat(to, "_toggled"), "".concat(showSubMenu));
    }
  }, [routeMatch, showSubMenu, to]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: type === "side" ? theme.subMenuParentWrapper : null
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(className ? className : navClass),
    onClick: function onClick() {
      if (_onClick) return _onClick;
      if (To[0]) history.push(To[0]);
    },
    onMouseLeave: function onMouseLeave() {
      return subMenuActivate === 'onHover' ? setShowSubMenu(false) : '';
    },
    onMouseOver: function onMouseOver() {
      return subMenuActivate === 'onHover' ? setShowSubMenu(true) : '';
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: 'flex'
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex-1 flex"
  }, !icon ? null : /*#__PURE__*/_react["default"].createElement(_Icons["default"], {
    icon: icon,
    className: type === "side" ? theme.menuIconSide : theme.menuIconTop
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: theme.navItemContent
  }, children)), /*#__PURE__*/_react["default"].createElement("div", {
    onClick: function onClick() {
      if (subMenuActivate === 'onClick') {
        localStorage.setItem("".concat(to, "_toggled"), "".concat(!showSubMenu));
        setShowSubMenu(!showSubMenu);
      }
    }
  }, subMenus.length ? /*#__PURE__*/_react["default"].createElement(_Icons["default"], {
    icon: showSubMenu ? theme.indicatorIconOpen : theme.indicatorIcon
  }) : null))), subMenus.length ? /*#__PURE__*/_react["default"].createElement(SubMenu, {
    showSubMenu: showSubMenu,
    subMenus: subMenus,
    type: type,
    themeOptions: themeOptions,
    className: className
  }) : '');
};

var _default = NavItem;
exports["default"] = _default;

var SubMenu = function SubMenu(_ref2) {
  var showSubMenu = _ref2.showSubMenu,
      subMenus = _ref2.subMenus,
      type = _ref2.type,
      themeOptions = _ref2.themeOptions;
  var theme = (0, _wrappers.useTheme)()[type === 'side' ? 'sidenav' : 'topnav'](themeOptions);

  if (!showSubMenu || !subMenus.length) {
    return null;
  }

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: type === "side" ? theme.subMenuWrapper : theme.subMenuWrapperTop
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(theme.contentBg, "\n\t\t\t\t\tflex\n\t\t\t\t\t").concat(type === "side" ? "flex-col" : "flex-row", "\n\t\t\t\t")
  }, subMenus.map(function (sm, i) {
    return /*#__PURE__*/_react["default"].createElement(NavItem, {
      key: i,
      to: sm.path,
      icon: sm.icon,
      type: type,
      className: sm.className,
      onClick: sm.onClick,
      themeOptions: themeOptions,
      subMenus: sm.subMenus
    }, sm.name);
  })));
};