"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NavMenuSeparator = exports.NavMenuItem = exports.NavMenu = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _utils = require("../utils");

var _withTheme = require("../../wrappers/with-theme");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var NavMenu = function NavMenu(_ref) {
  var control = _ref.control,
      children = _ref.children,
      customTheme = _ref.customTheme;

  var _React$useState = _react["default"].useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      open = _React$useState2[0],
      setOpen = _React$useState2[1],
      clickedOutside = _react["default"].useCallback(function () {
    return setOpen(false);
  }, []),
      _useClickOutside = (0, _utils.useClickOutside)(clickedOutside),
      _useClickOutside2 = _slicedToArray(_useClickOutside, 1),
      setRef = _useClickOutside2[0],
      theme = _objectSpread(_objectSpread({}, (0, _withTheme.useTheme)()), customTheme);

  return /*#__PURE__*/_react["default"].createElement("div", {
    ref: setRef,
    className: "".concat(theme.navMenu, " ").concat(open ? theme.navMenuOpen : ''),
    onMouseEnter: function onMouseEnter(e) {
      return setOpen(true);
    },
    onMouseLeave: function onMouseLeave(e) {
      return setOpen(false);
    },
    onClick: function onClick(e) {
      e.preventDefault();
      setOpen(!open);
    }
  }, open ? /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(theme.navMenuBg, " fixed p-3 -mt-5 ").concat(open ? "block" : "hidden", " z-10")
  }, children) : /*#__PURE__*/_react["default"].createElement("div", {
    className: "text-right h-full ".concat(open ? 'hidden' : 'block')
  }, control));
};

exports.NavMenu = NavMenu;

var NavMenuItem = function NavMenuItem(_ref2) {
  var _ref2$to = _ref2.to,
      to = _ref2$to === void 0 ? "#" : _ref2$to,
      children = _ref2.children;
  var theme = (0, _withTheme.useTheme)();
  return /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Link, {
    to: to
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(theme.transition, " ").concat(theme.navMenuItem)
  }, children));
};

exports.NavMenuItem = NavMenuItem;

var NavMenuSeparator = function NavMenuSeparator(_ref3) {
  var className = _ref3.className;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "border-b-2 my-1 text-gray-400 ".concat(className)
  });
};

exports.NavMenuSeparator = NavMenuSeparator;