"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactRouterDom = require("react-router-dom");

var _lodash = _interopRequireDefault(require("lodash.get"));

var _wrappers = require("../../wrappers");

var _Item = _interopRequireDefault(require("./Item"));

var _Top = require("./Top");

var _excluded = ["open", "toggle", "logo", "topMenu", "menuItems", "bottomMenu", "themeOptions", "subMenuActivate", "subMenuStyle"],
    _excluded2 = ["menuItems", "logo", "topMenu", "bottomMenu", "toggle", "open", "mobile", "themeOptions", "subMenuActivate", "subMenuStyle"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var sideBarItem = function sideBarItem(_ref) {
  var i = _ref.i,
      item = _ref.item,
      themeOptions = _ref.themeOptions,
      subMenuActivate = _ref.subMenuActivate;
  return /*#__PURE__*/_react["default"].createElement(_Item["default"], {
    key: i,
    to: item.path,
    icon: item.icon,
    className: item.className,
    onClick: item.onClick,
    themeOptions: themeOptions,
    subMenuActivate: subMenuActivate,
    subMenus: (0, _lodash["default"])(item, "subMenus", [])
  }, item.name);
};

var MobileSidebar = function MobileSidebar(_ref2) {
  var open = _ref2.open,
      toggle = _ref2.toggle,
      _ref2$logo = _ref2.logo,
      logo = _ref2$logo === void 0 ? null : _ref2$logo,
      topMenu = _ref2.topMenu,
      _ref2$menuItems = _ref2.menuItems,
      menuItems = _ref2$menuItems === void 0 ? [] : _ref2$menuItems,
      bottomMenu = _ref2.bottomMenu,
      _ref2$themeOptions = _ref2.themeOptions,
      themeOptions = _ref2$themeOptions === void 0 ? {} : _ref2$themeOptions,
      subMenuActivate = _ref2.subMenuActivate,
      subMenuStyle = _ref2.subMenuStyle,
      props = _objectWithoutProperties(_ref2, _excluded);

  var theme = (0, _wrappers.useTheme)()['sidenav'](themeOptions); // theme = props.theme || theme;

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "md:hidden",
    onClick: function onClick() {
      return toggle(!open);
    }
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: open ? theme.menuIconOpen : theme.menuIconClosed
  })), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: open ? "block" : "none"
    },
    className: "md:hidden"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "fixed inset-0 z-20 transition-opacity ease-linear duration-300"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "absolute inset-0 opacity-75"
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "fixed inset-0 flex z-40 ".concat(theme.contentBgAccent)
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex-1 flex flex-col max-w-xs w-full transform ease-in-out duration-300 ".concat(theme.contentBg)
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "absolute top-0 right-0 -mr-14 p-1"
  }, /*#__PURE__*/_react["default"].createElement("button", {
    onClick: function onClick() {
      return toggle(!open);
    },
    className: "flex items-center justify-center h-12 w-12 rounded-full focus:outline-none focus:bg-gray-600 os-icon os-icon-x"
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex-1 h-0 pt-2 pb-4 overflow-y-auto overflow-x-hidden"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "px-6 pt-4 pb-8 logo-text gray-900"
  }, /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Link, {
    to: "/",
    className: "flex-shrink-0 flex items-center ".concat(theme.text)
  }, logo)), /*#__PURE__*/_react["default"].createElement("div", null, topMenu), /*#__PURE__*/_react["default"].createElement("nav", {
    className: "flex-1"
  }, menuItems.map(function (page, i) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: i,
      className: page.sectionClass
    }, sideBarItem({
      i: i,
      page: page,
      themeOptions: themeOptions,
      subMenuActivate: subMenuActivate
    }));
  })), /*#__PURE__*/_react["default"].createElement("div", null, bottomMenu))))));
};

var DesktopSidebar = function DesktopSidebar(_ref3) {
  var _ref3$menuItems = _ref3.menuItems,
      menuItems = _ref3$menuItems === void 0 ? [] : _ref3$menuItems,
      _ref3$logo = _ref3.logo,
      logo = _ref3$logo === void 0 ? null : _ref3$logo,
      topMenu = _ref3.topMenu,
      bottomMenu = _ref3.bottomMenu,
      toggle = _ref3.toggle,
      open = _ref3.open,
      mobile = _ref3.mobile,
      _ref3$themeOptions = _ref3.themeOptions,
      themeOptions = _ref3$themeOptions === void 0 ? {} : _ref3$themeOptions,
      subMenuActivate = _ref3.subMenuActivate,
      subMenuStyle = _ref3.subMenuStyle,
      props = _objectWithoutProperties(_ref3, _excluded2);

  var theme = (0, _wrappers.useTheme)()['sidenav'](themeOptions); // console.log('SideNav', themeOptions, theme, useTheme()['sidenav'](themeOptions))

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(theme.sidenavWrapper)
  }, topMenu, /*#__PURE__*/_react["default"].createElement("nav", {
    className: "".concat(theme.itemsWrapper)
  }, menuItems.map(function (item, i) {
    return sideBarItem({
      i: i,
      item: item,
      themeOptions: themeOptions,
      subMenuActivate: subMenuActivate
    });
  })), bottomMenu), mobile === 'side' ? '' : /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(theme.topnavWrapper, " md:hidden")
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(theme.topnavContent, " justify-between")
  }, /*#__PURE__*/_react["default"].createElement("div", null, topMenu), /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex items-center justify-center h-full"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(theme.topmenuRightNavContainer)
  }, bottomMenu), /*#__PURE__*/_react["default"].createElement("button", {
    type: "button",
    className: theme.mobileButton,
    onClick: function onClick() {
      return toggle(!open);
    }
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: "sr-only"
  }, "Open main menu"), /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex justify-center items-center text-2xl"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: !open ? theme.menuOpenIcon : theme.menuCloseIcon
  })))))));
};

var SideNav = function SideNav(props) {
  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(DesktopSidebar, _extends({}, props, {
    open: open,
    toggle: setOpen
  })), props.mobile === 'side' ? /*#__PURE__*/_react["default"].createElement(MobileSidebar, _extends({
    open: open,
    toggle: setOpen
  }, props)) : /*#__PURE__*/_react["default"].createElement(_Top.MobileMenu, _extends({
    open: open
  }, props, {
    themeOptions: {}
  })));
};

var _default = SideNav;
exports["default"] = _default;