"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _TabPanel = _interopRequireDefault(require("./TabPanel"));

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

//import { useTheme } from "../../wrappers";
var Identity = function Identity(i) {
  return i;
};

var _default = {
  name: "TabPanel",
  themeVar: 'tabpanel',
  description: "Tab Panel for showing one thing at a time.",
  props: [{
    name: "tabs",
    "default": [],
    type: "Array"
  }, {
    name: "tabLocation",
    "default": "top",
    type: "String"
  }, {
    name: "activeIndex",
    "default": null,
    type: "Number"
  }, {
    name: "setActiveIndex",
    "default": null,
    type: "Function"
  }],
  examples: [{
    title: 'Simple',
    props: [{
      name: "tabs",
      "default": [{
        name: "tab one",
        icon: 'fa fa-album',
        Component: function Component() {
          return /*#__PURE__*/_react["default"].createElement("div", null, " This is Tab One");
        }
      }, {
        name: "tab two",
        icon: 'fa-duotone fa-album',
        Component: function Component() {
          return /*#__PURE__*/_react["default"].createElement("div", null, " This is Tab two");
        }
      }, {
        name: "tab three",
        icon: 'fa-thin fa-album',
        Component: function Component() {
          return /*#__PURE__*/_react["default"].createElement("div", null, "\"Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.\"");
        }
      }]
    }],
    Component: function Component(props) {
      var _React$useState = _react["default"].useState(''),
          _React$useState2 = _slicedToArray(_React$useState, 2),
          selected = _React$useState2[0],
          setSelected = _React$useState2[1];

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "h-full w-full bg-gray-100"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "max-w-5xl mx-auto py-12"
      }, /*#__PURE__*/_react["default"].createElement(_TabPanel["default"], props)));
    }
  }]
};
exports["default"] = _default;