"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _withTheme = require("../../wrappers/with-theme");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var TabPanel = function TabPanel(props) {
  var tabs = props.tabs,
      _props$activeIndex = props.activeIndex,
      activeIndex = _props$activeIndex === void 0 ? 0 : _props$activeIndex,
      _props$setActiveIndex = props.setActiveIndex,
      setActiveIndex = _props$setActiveIndex === void 0 ? null : _props$setActiveIndex,
      themeOptions = props.themeOptions;
  var theme = (0, _withTheme.useTheme)()['tabpanel'](themeOptions);

  var _React$useState = _react["default"].useState(activeIndex),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      activeTabIndex = _React$useState2[0],
      setActiveTabIndex = _React$useState2[1]; // ----------
  // when activeIndex is passed by props
  // update it on change
  // ----------


  _react["default"].useEffect(function () {
    setActiveTabIndex(activeIndex);
  }, [activeIndex]);

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(theme.tabpanelWrapper)
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(theme.tabWrapper)
  }, tabs.map(function (_ref, i) {
    var icon = _ref.icon,
        name = _ref.name;
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: i,
      onClick: function onClick(e) {
        return setActiveIndex ? setActiveIndex(i) : setActiveTabIndex(i);
      },
      className: "".concat(i === activeTabIndex ? theme.tabActive : theme.tab)
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: "".concat(icon, " ").concat(theme.icon)
    }), /*#__PURE__*/_react["default"].createElement("span", {
      className: "".concat(theme.tabName)
    }, " ", name, " "));
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(theme.contentWrapper)
  }, tabs.map(function (_ref2, i) {
    var Component = _ref2.Component;
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: i,
      style: {
        display: i === activeTabIndex ? "block" : "none"
      }
    }, /*#__PURE__*/_react["default"].createElement(Component, props));
  })));
};

var _default = TabPanel;
exports["default"] = _default;