"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactTable = require("react-table");

var _Button = require("../Button");

var _Inputs = require("../Inputs");

var _lodash = _interopRequireDefault(require("lodash.get"));

var _matchSorter = require("match-sorter");

var _withTheme = require("../../wrappers/with-theme");

var _excluded = ["columns", "data", "sortBy", "sortOrder", "initialPageSize", "pageSize", "onRowClick", "onRowEnter", "onRowLeave", "ExpandRow", "disableFilters", "disableSortBy", "themeOptions"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var DefaultColumnFilter = function DefaultColumnFilter(_ref) {
  var column = _ref.column;
  var _column$filterValue = column.filterValue,
      filterValue = _column$filterValue === void 0 ? "" : _column$filterValue,
      setFilter = column.setFilter; // count = preFilteredRows.length;

  var theme = (0, _withTheme.useTheme)().table();
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "w-3/4"
  }, /*#__PURE__*/_react["default"].createElement("input", {
    className: theme.inputSmall,
    value: filterValue,
    onChange: function onChange(e) {
      return setFilter(e.target.value);
    },
    onClick: function onClick(e) {
      return e.stopPropagation();
    },
    placeholder: "Search..."
  }));
};

var DropDownColumnFilter = function DropDownColumnFilter(_ref2) {
  var _ref2$column = _ref2.column,
      filterValue = _ref2$column.filterValue,
      setFilter = _ref2$column.setFilter,
      preFilteredRows = _ref2$column.preFilteredRows,
      id = _ref2$column.id,
      filterMeta = _ref2$column.filterMeta,
      filterDomain = _ref2$column.filterDomain,
      onFilterChange = _ref2$column.onFilterChange,
      customValue = _ref2$column.customValue,
      filterThemeOptions = _ref2$column.filterThemeOptions,
      filterClassName = _ref2$column.filterClassName,
      filterMulti = _ref2$column.filterMulti,
      _ref2$column$filterRe = _ref2$column.filterRemovable,
      filterRemovable = _ref2$column$filterRe === void 0 ? true : _ref2$column$filterRe;

  // Calculate the options for filtering
  // using the preFilteredRows
  var options = _react["default"].useMemo(function () {
    var options = new Set();

    if (filterMeta) {
      return filterMeta;
    }

    preFilteredRows.forEach(function (row) {
      options.add(row.values[id]);
    });
    return _toConsumableArray(options.values());
  }, [filterMeta, id, preFilteredRows]).filter(function (d) {
    return d;
  });

  var count = preFilteredRows.length; // Render a multi-select box

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: ""
  }, /*#__PURE__*/_react["default"].createElement(_Inputs.Select, {
    domain: filterDomain || options,
    value: filterValue || customValue || [] // value = {['row2']}
    ,
    onChange: function onChange(e) {
      setFilter(e || undefined);
      onFilterChange(e || undefined); // Set undefined to remove the filter entirely
    },
    placeHolder: "Search ".concat(count, " records..."),
    removable: filterRemovable,
    multi: filterMulti,
    themeOptions: filterThemeOptions,
    className: "".concat(filterClassName)
  }));
};

function fuzzyTextFilterFn(rows, id, filterValue) {
  return (0, _matchSorter.matchSorter)(rows, filterValue, {
    keys: [function (row) {
      return row.values[id];
    }]
  });
}

function DropDownFilterFn(rows, id, filterValue) {
  return rows.filter(function (row) {
    var rowValue = row.values[id];
    return rowValue !== undefined && Array.isArray(filterValue) && filterValue.length ? filterValue.includes(rowValue) : rowValue !== undefined && filterValue.length ? rowValue === filterValue : true;
  });
}

var getPageSpread = function getPageSpread(page, maxPage) {
  var low = page - 2,
      high = page + 2;

  if (low < 0) {
    high += -low;
    low = 0;
  }

  if (high > maxPage) {
    low -= high - maxPage;
    high = maxPage;
  }

  var spread = [];

  for (var i = Math.max(0, low); i <= Math.min(maxPage, high); ++i) {
    spread.push(i);
  }

  return spread;
};

var DefaultExpandedRow = function DefaultExpandedRow(_ref3) {
  var values = _ref3.values;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex"
  }, values.map(function (_ref4, i) {
    var key = _ref4.key,
        value = _ref4.value;
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: key || "key-".concat(i),
      className: "flex-1"
    }, key ? /*#__PURE__*/_react["default"].createElement("b", null, key, ":") : null, /*#__PURE__*/_react["default"].createElement("span", {
      className: "ml-1"
    }, value));
  }));
};

var EMPTY_ARRAY = [];

var _default = function _default(_ref5) {
  var _ref5$columns = _ref5.columns,
      columns = _ref5$columns === void 0 ? EMPTY_ARRAY : _ref5$columns,
      _ref5$data = _ref5.data,
      data = _ref5$data === void 0 ? EMPTY_ARRAY : _ref5$data,
      sortBy = _ref5.sortBy,
      _ref5$sortOrder = _ref5.sortOrder,
      sortOrder = _ref5$sortOrder === void 0 ? "" : _ref5$sortOrder,
      _ref5$initialPageSize = _ref5.initialPageSize,
      initialPageSize = _ref5$initialPageSize === void 0 ? 10 : _ref5$initialPageSize,
      _ref5$pageSize = _ref5.pageSize,
      pageSize = _ref5$pageSize === void 0 ? null : _ref5$pageSize,
      onRowClick = _ref5.onRowClick,
      onRowEnter = _ref5.onRowEnter,
      onRowLeave = _ref5.onRowLeave,
      _ref5$ExpandRow = _ref5.ExpandRow,
      ExpandRow = _ref5$ExpandRow === void 0 ? DefaultExpandedRow : _ref5$ExpandRow,
      _ref5$disableFilters = _ref5.disableFilters,
      disableFilters = _ref5$disableFilters === void 0 ? false : _ref5$disableFilters,
      _ref5$disableSortBy = _ref5.disableSortBy,
      disableSortBy = _ref5$disableSortBy === void 0 ? false : _ref5$disableSortBy,
      _ref5$themeOptions = _ref5.themeOptions,
      themeOptions = _ref5$themeOptions === void 0 ? {} : _ref5$themeOptions,
      props = _objectWithoutProperties(_ref5, _excluded);

  var theme = (0, _withTheme.useTheme)().table(themeOptions);

  var filterTypes = _react["default"].useMemo(function () {
    return {
      fuzzyText: fuzzyTextFilterFn,
      dropdown: DropDownFilterFn
    };
  }, []);

  var filters = _react["default"].useMemo(function () {
    return {
      dropdown: DropDownColumnFilter
    };
  }, []);

  var defaultColumn = _react["default"].useMemo(function () {
    return {
      Filter: false
    };
  }, []);

  var _useTable = (0, _reactTable.useTable)({
    columns: columns,
    data: data,
    defaultColumn: defaultColumn,
    filterTypes: filterTypes,
    disableFilters: disableFilters,
    disableSortBy: disableSortBy,
    initialState: {
      pageSize: pageSize || initialPageSize,
      sortBy: [{
        id: sortBy,
        desc: sortOrder.toLowerCase() === "desc"
      }]
    }
  }, _reactTable.useFilters, _reactTable.useGlobalFilter, _reactTable.useSortBy, _reactTable.useExpanded, _reactTable.usePagination),
      getTableProps = _useTable.getTableProps,
      getTableBodyProps = _useTable.getTableBodyProps,
      headerGroups = _useTable.headerGroups,
      page = _useTable.page,
      rows = _useTable.rows,
      preFilteredRows = _useTable.preFilteredRows,
      prepareRow = _useTable.prepareRow,
      canPreviousPage = _useTable.canPreviousPage,
      canNextPage = _useTable.canNextPage,
      gotoPage = _useTable.gotoPage,
      previousPage = _useTable.previousPage,
      nextPage = _useTable.nextPage,
      pageCount = _useTable.pageCount,
      visibleColumns = _useTable.visibleColumns,
      toggleRowExpanded = _useTable.toggleRowExpanded,
      setPageSize = _useTable.setPageSize,
      _useTable$state = _useTable.state,
      statePageSize = _useTable$state.pageSize,
      pageIndex = _useTable$state.pageIndex,
      expanded = _useTable$state.expanded;

  _react["default"].useEffect(function () {
    if (pageSize !== null && pageSize !== statePageSize) {
      setPageSize(pageSize);
    }
  }, [pageSize, statePageSize, setPageSize]);

  if (!(columns.length && data.length)) return null;
  if (!preFilteredRows.length) return null;

  var filterLocationToClass = _defineProperty({
    inline: 'flex-row'
  }, undefined, 'flex-col');

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "w-full"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "overflow-auto scrollbar-sm"
  }, /*#__PURE__*/_react["default"].createElement("table", _extends({}, getTableProps(), {
    className: "w-full"
  }), /*#__PURE__*/_react["default"].createElement("thead", null, headerGroups.map(function (headerGroup) {
    return /*#__PURE__*/_react["default"].createElement("tr", headerGroup.getHeaderGroupProps(), headerGroup.headers.map(function (column) {
      return /*#__PURE__*/_react["default"].createElement("th", _extends({}, column.getHeaderProps(_objectSpread(_objectSpread({}, column.getSortByToggleProps()), {}, {
        style: {
          minWidth: column.minWidth,
          width: column.width,
          maxWidth: column.maxWidth
        }
      })), {
        className: theme.tableHeader
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: 'flex flex-col'
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "flex justify-between"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "flex-1 pr-1"
      }, column.render("Header")), !column.canSort ? null : !column.isSorted ? /*#__PURE__*/_react["default"].createElement("i", {
        className: "ml-2 pt-1 ".concat(theme.sortIconIdeal)
      }) : column.isSortedDesc ? /*#__PURE__*/_react["default"].createElement("i", {
        className: "ml-2 pt-1 ".concat(theme.sortIconDown)
      }) : /*#__PURE__*/_react["default"].createElement("i", {
        className: "ml-2 pt-1 ".concat(theme.sortIconUp)
      })), /*#__PURE__*/_react["default"].createElement("div", null, !column.canFilter ? null : /*#__PURE__*/_react["default"].createElement("div", null, column.render(filters[column.filter] || 'Filter')))));
    }));
  })), /*#__PURE__*/_react["default"].createElement("tbody", getTableBodyProps(), page.map(function (row) {
    var _row$original = row.original,
        _onClick = _row$original.onClick,
        _row$original$expand = _row$original.expand,
        expand = _row$original$expand === void 0 ? [] : _row$original$expand;
    prepareRow(row);
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
      key: row.getRowProps().key
    }, /*#__PURE__*/_react["default"].createElement("tr", _extends({}, row.getRowProps(), {
      onMouseEnter: typeof onRowEnter === "function" ? function (e) {
        return onRowEnter(e, row);
      } : null,
      onMouseLeave: typeof onRowLeave === "function" ? function (e) {
        return onRowLeave(e, row);
      } : null,
      className: "\n                        ".concat(props.striped ? theme.tableRowStriped : theme.tableRow, "\n                        ").concat(_onClick || onRowClick ? "cursor-pointer" : "", "\n                      "),
      onClick: function onClick(e) {
        typeof onRowClick === "function" && onRowClick(e, row);
        typeof _onClick === "function" && _onClick(e, row);
      }
    }), row.cells.map(function (cell, ii) {
      return /*#__PURE__*/_react["default"].createElement("td", _extends({}, cell.getCellProps({
        style: {
          minWidth: cell.column.minWidth,
          maxWidth: cell.column.maxWidth,
          width: cell.column.width
        }
      }), {
        className: "text-".concat((0, _lodash["default"])(columns.find(function (c) {
          return c.Header === cell.column.Header;
        }), 'align') || 'center', " ").concat(theme.tableCell)
      }), ii > 0 || row.subRows.length === 0 && expand.length === 0 ? cell.render('Cell') : /*#__PURE__*/_react["default"].createElement("div", {
        className: "flex items-center"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "flex-1"
      }, cell.render('Cell')), /*#__PURE__*/_react["default"].createElement("div", {
        onClick: function onClick(e) {
          e.stopPropagation();
          e.preventDefault();
          Object.keys(expanded).filter(function (k) {
            return k !== row.id;
          }).forEach(toggleRowExpanded);
          row.toggleRowExpanded(!row.isExpanded);
        },
        className: "\n                                        flex item-center justify-center\n                                        rounded cursor-pointer py-1 px-2\n                                        hover:".concat(theme.accent3, " ").concat(theme.transition, "\n                                      ")
      }, row.isExpanded ? /*#__PURE__*/_react["default"].createElement("i", {
        className: "fas fa-chevron-up"
      }) : /*#__PURE__*/_react["default"].createElement("i", {
        className: "fas fa-chevron-down"
      }))));
    })), !row.isExpanded || !expand.length ? null : /*#__PURE__*/_react["default"].createElement("tr", {
      className: theme.tableRow
    }, /*#__PURE__*/_react["default"].createElement("td", {
      colSpan: visibleColumns.length,
      className: theme.tableCell
    }, /*#__PURE__*/_react["default"].createElement(ExpandRow, {
      values: expand
    }))));
  })))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "w-full p-2"
  }, pageCount <= 1 ? null : /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex items-center ".concat(theme.textInfo)
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex-0"
  }, "Page ", pageIndex + 1, " of ", pageCount, /*#__PURE__*/_react["default"].createElement("br", null), "Rows ", pageIndex * statePageSize + 1, "-", Math.min(rows.length, pageIndex * statePageSize + statePageSize), " of ", rows.length), /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex-1 flex justify-end items-center"
  }, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    disabled: pageIndex === 0,
    themeOptions: {
      size: 'sm'
    },
    onClick: function onClick(e) {
      return gotoPage(0);
    }
  }, "<<"), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    disabled: !canPreviousPage,
    themeOptions: {
      size: 'sm'
    },
    onClick: function onClick(e) {
      return previousPage();
    }
  }, "<"), getPageSpread(pageIndex, pageCount - 1).map(function (p) {
    var active = p === pageIndex;
    return /*#__PURE__*/_react["default"].createElement(_Button.Button, {
      key: p,
      themeOptions: {
        size: 'sm',
        color: active ? 'primary' : 'white'
      },
      onClick: active ? null : function (e) {
        return gotoPage(p);
      }
    }, p + 1);
  }), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    disabled: !canNextPage,
    themeOptions: {
      size: 'sm'
    },
    onClick: function onClick(e) {
      return nextPage(0);
    }
  }, ">"), /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    disabled: pageIndex === pageCount - 1,
    themeOptions: {
      size: 'sm'
    },
    onClick: function onClick(e) {
      return gotoPage(pageCount - 1);
    }
  }, ">>")))));
};

exports["default"] = _default;