"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactTransitionGroup = require("react-transition-group");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var _default = function _default(_ref) {
  var show = _ref.show,
      enter = _ref.enter,
      enterFrom = _ref.enterFrom,
      enterTo = _ref.enterTo,
      leave = _ref.leave,
      leaveFrom = _ref.leaveFrom,
      leaveTo = _ref.leaveTo,
      classNames = _ref.classNames,
      children = _ref.children;
  var enterClasses = enter && enter.split(" ");
  var enterFromClasses = enterFrom.split(" ");
  var enterToClasses = enterTo.split(" ");
  var leaveClasses = leave && leave.split(" ");
  var leaveFromClasses = leaveFrom.split(" ");
  var leaveToClasses = leaveTo.split(" ");
  return /*#__PURE__*/_react["default"].createElement(_reactTransitionGroup.CSSTransition, {
    classNames: classNames,
    unmountOnExit: true,
    "in": show,
    addEndListener: function addEndListener(node, done) {
      node.addEventListener("transitionend", done, false);
    },
    onEnter: function onEnter(node) {
      var _node$classList;

      (_node$classList = node.classList).add.apply(_node$classList, _toConsumableArray(enter && enterClasses).concat(_toConsumableArray(enterFromClasses)));
    },
    onEntering: function onEntering(node) {
      var _node$classList2, _node$classList3;

      (_node$classList2 = node.classList).remove.apply(_node$classList2, _toConsumableArray(enterFromClasses));

      (_node$classList3 = node.classList).add.apply(_node$classList3, _toConsumableArray(enterToClasses));
    },
    onEntered: function onEntered(node) {
      var _node$classList4;

      (_node$classList4 = node.classList).remove.apply(_node$classList4, _toConsumableArray(enter && enterToClasses).concat(_toConsumableArray(enterClasses)));
    },
    onExit: function onExit(node) {
      var _node$classList5;

      (_node$classList5 = node.classList).add.apply(_node$classList5, _toConsumableArray(leave && leaveClasses).concat(_toConsumableArray(leaveFromClasses)));
    },
    onExiting: function onExiting(node) {
      var _node$classList6, _node$classList7;

      (_node$classList6 = node.classList).remove.apply(_node$classList6, _toConsumableArray(leaveFromClasses));

      (_node$classList7 = node.classList).add.apply(_node$classList7, _toConsumableArray(leaveToClasses));
    },
    onExited: function onExited(node) {
      var _node$classList8;

      (_node$classList8 = node.classList).remove.apply(_node$classList8, _toConsumableArray(leaveToClasses).concat(_toConsumableArray(leave && leaveClasses)));
    }
  }, children);
};

exports["default"] = _default;