"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getColorRange = exports.ColorRanges = exports.ColorBar = void 0;

var _react = _interopRequireDefault(require("react"));

var _colorbrewer = _interopRequireDefault(require("colorbrewer"));

var _lodash = _interopRequireDefault(require("lodash.get"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var ColorRanges = {};
exports.ColorRanges = ColorRanges;

var _loop = function _loop(type) {
  _colorbrewer["default"].schemeGroups[type].forEach(function (name) {
    var group = _colorbrewer["default"][name];

    for (var length in group) {
      if (!(length in ColorRanges)) {
        ColorRanges[length] = [];
      }

      ColorRanges[length].push({
        type: "".concat(type[0].toUpperCase()).concat(type.slice(1)),
        name: name,
        category: "Colorbrewer",
        colors: group[length]
      });
    }
  });
};

for (var type in _colorbrewer["default"].schemeGroups) {
  _loop(type);
}

//console.log("ColorRanges", ColorRanges);
var getColorRange = function getColorRange(size, name) {
  var reverse = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var range = (0, _lodash["default"])(ColorRanges, [size], []).reduce(function (a, c) {
    return c.name === name ? c.colors : a;
  }, []).slice();

  if (reverse) {
    range.reverse();
  }

  return range;
};

exports.getColorRange = getColorRange;

var ColorBar = function ColorBar(_ref) {
  var colors = _ref.colors,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 3 : _ref$size;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "flex"
  }, colors.map(function (c, i) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: i,
      style: {
        backgroundColor: c,
        transition: "background-color 0.5s"
      },
      className: "flex-1 h-".concat(size)
    });
  }));
};

exports.ColorBar = ColorBar;